#!/usr/bin/env python

#Creates multiple Connections to a broker 
#and sends and receives messages. Support SSL and Normal connections
#uses the loop_start and stop functions just like a single client
#Shows number of thread used

import paho.mqtt.client as mqtt
import time
import json
import threading
import logging

broker="192.168.xxx.xxx"    ## ip-adresse von mosquitto mqtt-broker
port =1883
ssl_port=8883 
qi=0
s_flag=0
p_flag=0
i_flag=0
z1=0
zlist=[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]
pwrlistb=["Volt","Curr","Tempr","Vlow","Vhigh","BaseSt","VoltSt","CurrSt","TempSt","Coulomb"]
#pwrlist=[1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0]
pwrlist2d=[[1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0],
          [1.0,1.0,1.0,1.0,1.0,"Charge","Normal","Normal","Normal",0]]

pwrlisti=[19,20,21,24,25,26,27,28,29,30]
statlistb=[]
statlist=[]
#statlist  49 eintraege

pwrbat=1
ftopicz=1
stopictyp=1  #pwr=1 #bat=2 #stat=3 #info=4
pzeile=""
bzeile=""
szeile=""
izeile=""

Normal_connections=1
SSL_Connections=0 #no ssl connections illustration only
message="test message"
topic="broker-test/test1"
topicr="#"
#topicr="pylonp"
topics="pylontech/1/z1"
 

out_queue=[] #use simple array to get printed messages in some form of order
def on_log(client, userdata, level, buf):
   global port 
   #print(buf)
def on_message(client, userdata, message):
   #a=message.payload
   a=message.payload.decode("utf-8")
   mtopic = message.topic
   #print(a)
   print(mtopic)
   global s_flag
   global p_flag
   global i_flag
   global z1
   global zlist
   global ftopicz
   global stopictyp
   global pwrlist2d
   global pwrlistb
   global pzeile
   global bzeile
   global szeile
   global izeile
   global statlistb
   global statlist
   ##time.sleep(1)
   #msg="message received",str(message.payload.decode("utf-8"))
   #print(msg)
   #out_queue.append(msg)
   #print(message.topic)
   #mtopic = message.topic
   ######################
   suchtopicf="pylonp"
   #suchtopicf="pylon1b"
   #print(" findfirst suchtopicf = "+suchtopicf)
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       stopictyp = 1  # zwischendurch umgschalten wegen warten
       print(" findfirst hat umgeschaltet "+suchtopicf)
       #p_flag=p_flag+1
   suchtopicf="pylon1b"
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       print(" findfirst pylon1b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 1
   suchtopicf="pylon2b"
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       print(" findfirst pylon2b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 2
   suchtopicf="pylon3b"
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       print(" findfirst pylon3b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 3
   suchtopicf="pylon4b"
   ftopicf = mtopic.find(suchtopicf) 
   if (ftopicf==0):
       print(" findfirst pylon4b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 4
   suchtopicf="pylon5b"
   ftopicf = mtopic.find(suchtopicf)       
   if (ftopicf==0):
       print(" findfirst pylon5b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 5
   suchtopicf="pylon6b"
   ftopicf = mtopic.find(suchtopicf)       
   if (ftopicf==0):
       print(" findfirst pylon6b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 6
   suchtopicf="pylon7b"
   ftopicf = mtopic.find(suchtopicf)       
   if (ftopicf==0):
       print(" findfirst pylon7b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 7
   suchtopicf="pylon8b"
   ftopicf = mtopic.find(suchtopicf) 
   if (ftopicf==0):
       print(" findfirst pylon8b gefunden "+suchtopicf)
       stopictyp = 2  # zwischendurch umgschalten wegen warten
       ftopicz = 8

   
   


   suchtopicf="pylon1s"
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       print(" findfirst pylon1s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 1
       #ftopicz = 2
   suchtopicf="pylon2s"
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       print(" findfirst pylon2s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 2
       #ftopicz = 3
   suchtopicf="pylon3s"
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       print(" findfirst pylon3s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 3
       #ftopicz = 4
   suchtopicf="pylon4s"
   ftopicf = mtopic.find(suchtopicf) 
   if (ftopicf==0):
       print(" findfirst pylon4s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 4
       #ftopicz = 5
   suchtopicf="pylon5s"
   ftopicf = mtopic.find(suchtopicf)       
   if (ftopicf==0):
       print(" findfirst pylon5s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 5
       #ftopicz = 6
   suchtopicf="pylon6s"
   ftopicf = mtopic.find(suchtopicf)       
   if (ftopicf==0):
       print(" findfirst pylon6s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 6
       #ftopicz = 7
   suchtopicf="pylon7s"
   ftopicf = mtopic.find(suchtopicf)       
   if (ftopicf==0):
       print(" findfirst pylon7s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 7
       #ftopicz = 8
   suchtopicf="pylon8s"
   ftopicf = mtopic.find(suchtopicf) 
   if (ftopicf==0):
       print(" findfirst pylon8s gefunden "+suchtopicf)
       stopictyp = 3  # zwischendurch umgschalten wegen warten
       ftopicz = 8
       #ftopicz = 1

   suchtopicf="pyloni"
   #print(" findfirst suchtopicf = "+suchtopicf)
   ftopicf = mtopic.find(suchtopicf)
   if (ftopicf==0):
       stopictyp = 4  # zwischendurch umgschalten wegen warten
       print(" findfirst hat pyloni gefunden und umgeschaltet "+suchtopicf)
       #p_flag=p_flag+1


   
   
   ######################
   #print(stopictyp)
   if (stopictyp>4):
       stopictyp = 1 

   #print(" nach findfirst>>>>>  stopictyp "+str(stopictyp)+" p_flag "+str(p_flag)+ " s_flag "+str(s_flag)+" len-a "+str(len(a)) )

   if (stopictyp==1) :    #pwr=1
      print("stopictyp=1 "+str(stopictyp)+" p_flag "+str(p_flag)+ " s_flag "+str(s_flag)+" len-a "+str(len(a)) ) 
      #print(a)
      if (len(a)>1000):
          print(a)
          suchtopic="pylonp"
          ftopic = mtopic.find(suchtopic)
          if (ftopic==0):
             p_flag=p_flag+2
 

   if (p_flag>1):    
       suchtopic="pylonp"
       print(" find suchtopic = "+suchtopic)
       ftopic = mtopic.find(suchtopic)
       if (ftopic==0):
          print("topic "+suchtopic+"  gefunden !!! ")
          print("PPPEEEEEEEEEEEEEEEEEEEEEEEEEEEEE")
          print(a)
          adzeile = str(a)
          
          ######################msg#########################################
          print(" beginn pylonp msg schleife ")
          #print("Power Uebersicht ")
          pzeile1= str(a)[6:142]     #diff 139 ##
          #print(pzeile1)
          pzeile2= str(a)[150:286]   #diff 141-abstand  diff 
          print(pzeile2)
          pzeile3= str(a)[291:427]   #diff 141-abstand  diff 136  ##
          #print(pzeile3)
          pzeile4= str(a)[432:568]   #diff 141
          #print(pzeile4)
          pzeile5= str(a)[573:709]   #diff 141
          #print(pzeile5)
          pzeile6= str(a)[714:850]   #diff 141
          #print(pzeile6)
          pzeile7= str(a)[855:991]   #diff 141
          #print(pzeile7)
          pzeile8= str(a)[996:1132]   #diff 141
          #print(pzeile8)
          pzeile9= str(a)[1137:1273]   #diff 141
          #print(pzeile9)
          
          #pzeile = "Gesamtsicht Batterien\n"+ pzeile1+"\n"+pzeile2+"\n"+pzeile3+"\n"+pzeile4+"\n"+pzeile5+"\n"
          #pzeile = pzeile1+"\n"+pzeile2+"\n"+pzeile3+"\n"+pzeile4+"\n"+pzeile5+"\n"+pzeile6+"\n"+pzeile7+"\n"+pzeile8+"\n"+pzeile9
          pzeile = pzeile2+"\n"+pzeile3+"\n"+pzeile4+"\n"+pzeile5+"\n"+pzeile6+"\n"+pzeile7+"\n"+pzeile8+"\n"+pzeile9
          #pzeile = pzeile2+pzeile3+pzeile4+pzeile5+pzeile6+pzeile7+pzeile8+pzeile9
          #pzeile = pzeile+pzeile6+"\n"+pzeile7+"\n"+pzeile8+"\n"+pzeile9
          print(pzeile)
          print(" ende  pylonp msg  schleife ")
          ######################msg#########################################
          
         
          lzeile=adzeile.split()
          #zlist=[]
          i=0
          j=0
          k=0
          print(" beginn listen schleife ")
          while j <= 135:
              #print(j)
              i=0
              while i <= 9:
                 #print(i) 
                 #print( lzeile[pwrlisti[i]+j] )
                 if (i<5) :
                     #print( float(lzeile[pwrlisti[i]+j])/1000 )
                     pwrlist2d[k][i] = float(lzeile[pwrlisti[i]+j])/1000
                 elif (i<9) :
                     #print( lzeile[pwrlisti[i]+j] )
                     pwrlist2d[k][i] = lzeile[pwrlisti[i]+j]
                 elif (i==9) :
                     #print( str(lzeile[pwrlisti[i]+j])[:-1] )
                     pwrlist2d[k][i] = str(lzeile[pwrlisti[i]+j])[:-1]
                 i += 1

              j += 17
              k += 1
          print(" ende listen schleife ")
          #s_flag=s_flag+1
          
  
   ######################
   
   elif (stopictyp==2) :  #bat=2
       if (ftopicz>8):
         ftopicz = 1 
         #stopictyp = stopictyp + 1
         
       suchtopic="pylon"+str(ftopicz)+"b"
       print(" find suchtopic = "+suchtopic)
   
       #ftopic = mtopic.find("pylonp")
       #ftopic = mtopic.find("pylon1b") 
       ftopic = mtopic.find(suchtopic)
       if (ftopic==0):
          print("topic "+suchtopic+"  gefunden !!! ")
          print("EEEEEEEEEEEEEEEEEEEEEEEEEEEEEE")
          #print(a)
          
          if (len(a)>100):
             s_flag=s_flag+2
          
          #s_flag=s_flag+1
          if (s_flag>1):
             print(" AAAAAAAAAAAAAAAAAAAAAAAAAAAAAA") 
             print(a)
         
             adzeile = str(a)     #message nach string
             
             ####################msg###############################
             print("Bat Zellen Spanungen ")
             bzeile1= str(a)[8:24]      #diff 106 ##
             print(bzeile1)
             bzeile2= str(a)[114:127]   #diff 110 laenge 13
             print(bzeile2)
             bzeile3= str(a)[224:237]   #diff 110 laenge 13  
             print(bzeile3)
             bzeile4= str(a)[334:347]   #diff 110 laenge 13
             print(bzeile4)
             bzeile5= str(a)[444:457]   #diff 110 laenge 13
             print(bzeile5)
             bzeile6= str(a)[554:567]   #diff 110 laenge 13
             print(bzeile6)
             bzeile7= str(a)[664:677]   #diff 110 laenge 13
             print(bzeile7)
             bzeile8= str(a)[774:787]   #diff 110 laenge 13
             print(bzeile8)
             bzeile9= str(a)[884:897]   #diff 110 laenge 13
             print(bzeile9)
             bzeile10= str(a)[994:1007]   #diff 110 laenge 13
             print(bzeile10)
             bzeile11= str(a)[1104:1117]   #diff 110 laenge 13
             print(bzeile11)
             bzeile12= str(a)[1214:1227]   #diff 110 laenge 13
             print(bzeile12)
             bzeile13= str(a)[1324:1337]   #diff 110 laenge 13
             print(bzeile13)
             bzeile14= str(a)[1434:1447]   #diff 110 laenge 13
             print(bzeile14)
             bzeile15= str(a)[1544:1557]   #diff 110 laenge 13
             print(bzeile15)
             bzeile16= str(a)[1654:1667]   #diff 110 laenge 13
             print(bzeile16)
             
             bzeile = bzeile2+"\n"+bzeile3+"\n"+bzeile4+"\n"+bzeile5+"\n"+bzeile6+"\n"+bzeile7+"\n"+bzeile8+"\n"+bzeile9+"\n"
             bzeile = bzeile+bzeile10+"\n"+bzeile11+"\n"+bzeile12+"\n"+bzeile13+"\n"+bzeile14 +"\n"+bzeile15+"\n"+bzeile16
             print(bzeile)
             ####################msg##############################
           
             lzeile=adzeile.split()
             #zlist=[]
             i=17
             ti=1
             print(" beginn b-schleife ")
             while i <= 176:
                 print(i)
                 print(ti)
                 print(zlist[ti])
                 print(lzeile[i])
                 zlist[ti] = (float(lzeile[i]) / 1000)
                 print(" z"+str(ti)+" = " + str(zlist[ti]))
                 print("pylontech/"+str(ftopicz)+"/z"+str(ti)+" "+ str(zlist[ti]))
                 i += 11
                 ti += 1
               
             print(" ende b-schleife ")
             #ftopicz = ftopicz + 1
         


   ######################
   
   elif (stopictyp==3) :  #stat=3
       print("stopictyp=3 "+str(stopictyp)+" p_flag "+str(p_flag)+ " s_flag "+str(s_flag)+" len-a "+str(len(a)) )
       if (ftopicz>8):
         ftopicz = 1 
         #stopictyp = stopictyp + 1
         
       suchtopic="pylon"+str(ftopicz)+"s"
       print(" elif find suchtopic = "+suchtopic)
   
       ftopic = mtopic.find(suchtopic)
       if (ftopic==0):
          print("topic stat "+suchtopic+"  gefunden !!! ")
          print("SSSSSSSSSSSSSSEEEEEEEEEEEEEEE"+str(s_flag)+" len "+str(len(a)))
          #print(a)
          if (len(a)>1000):
             s_flag=s_flag+2
          if (s_flag>1):
             print(" SSSSSSSSSSSAAAAAAAAAAAAA"+str(s_flag)+" len "+str(len(a)) ) 
             print(a)
         
             adzeile = str(a)        #message nach string
            
             #######################msg#############################################
             print("Stat Bat Status --->>> ")
             szeile1= str(a)[12:38]   #<>#diff 29 laenge 26
             print(szeile1)
             szeile2= str(a)[41:67]   #diff 29 laenge 26
             #print(szeile2)
             szeile3= str(a)[70:96]   #diff 29 laenge 26  
             #print(szeile3)
             szeile4= str(a)[99:125]   #diff 29 laenge 26
             #print(szeile4)
             szeile5= str(a)[128:154]  #<> #diff 29 laenge 26
             print(szeile5)
             szeile6= str(a)[157:183]   #<>#diff 29 laenge 26
             print(szeile6)
             szeile7= str(a)[186:212]   #<>#diff 29 laenge 26
             print(szeile7)
             szeile8= str(a)[215:241]   #<>#diff 29 laenge 26
             print(szeile8)
             szeile9= str(a)[244:270]   #<>#diff 29 laenge 26
             print(szeile9)
             szeile10= str(a)[273:299]   #diff 29 laenge 26
             #print(szeile10)

             szeile11= str(a)[302:328]   #diff 29 laenge 26
             #print(szeile11)
             szeile12= str(a)[331:357]   #diff 29 laenge 26
             #print(szeile12)
             szeile13= str(a)[360:386]   #diff 29 laenge 26
             #print(szeile13)
             szeile14= str(a)[389:415]   #diff 29 laenge 26
             #print(szeile14)
             szeile15= str(a)[418:444]   #<>#diff 29 laenge 26
             print(szeile15)
             szeile16= str(a)[447:473]   #<>#diff 29 laenge 26
             print(szeile16)
             szeile17= str(a)[476:502]   #diff 29 laenge 26
             #print(szeile17)
             szeile18= str(a)[505:531]   #diff 29 laenge 26
             #print(szeile18)
             szeile19= str(a)[534:560]   #diff 29 laenge 26
             #print(szeile19)
             szeile20= str(a)[563:589]   #<>#diff 29 laenge 26
             print(szeile20)

             szeile21= str(a)[592:618]   #<>#diff 29 laenge 26
             print(szeile21)
             szeile22= str(a)[621:647]   #diff 29 laenge 26
             #print(szeile22)
             szeile23= str(a)[650:676]   #diff 29 laenge 26
             #print(szeile23)
             szeile24= str(a)[679:705]   #diff 29 laenge 26
             #print(szeile24)
             szeile25= str(a)[708:734]   #diff 29 laenge 26
             #print(szeile25)
             szeile26= str(a)[737:763]   #diff 29 laenge 26
             #print(szeile26)
             szeile27= str(a)[766:792]   #diff 29 laenge 26
             #print(szeile27)
             szeile28= str(a)[795:821]   #diff 29 laenge 26
             #print(szeile28)
             szeile29= str(a)[824:850]   #diff 29 laenge 26
             #print(szeile29)
             szeile30= str(a)[853:879]   #diff 29 laenge 26
             #print(szeile30)

             szeile31= str(a)[882:908]   #diff 29 laenge 26
             #print(szeile31)
             szeile32= str(a)[911:937]   #diff 29 laenge 26
             #print(szeile32)
             szeile33= str(a)[940:966]   #<>#diff 29 laenge 26
             print(szeile33)
             szeile34= str(a)[969:995]   #<>#diff 29 laenge 26
             print(szeile34)
             szeile35= str(a)[998:1024]   #diff 29 laenge 26
             #print(szeile35)
             szeile36= str(a)[1027:1053]   #diff 29 laenge 26
             #print(szeile36)
             szeile37= str(a)[1056:1082]   #<>#diff 29 laenge 26
             print(szeile37)
             szeile38= str(a)[1085:1111]   #diff 29 laenge 26
             #print(szeile38)
             szeile39= str(a)[1114:1140]   #<>#diff 29 laenge 26
             print(szeile39)
             szeile40= str(a)[1143:1169]   #<>#diff 29 laenge 26
             print(szeile40)
             
             szeile41= str(a)[1172:1198]  #<> #diff 29 laenge 26
             print(szeile41)
             szeile42= str(a)[1202:1228]  #<> #diff 29 laenge 26   ###+1??
             print(szeile42)
             szeile43= str(a)[1231:1257]   #diff 29 laenge 26
             #print(szeile43)
             szeile44= str(a)[1260:1286]   #diff 29 laenge 26
             #print(szeile44)
             szeile45= str(a)[1289:1315]   #diff 29 laenge 26
             #print(szeile45)
             szeile46= str(a)[1318:1344]   #diff 29 laenge 26
             #print(szeile46)
             szeile47= str(a)[1347:1373]   #diff 29 laenge 26
             #print(szeile47)
             szeile48= str(a)[1376:1402]   #diff 29 laenge 26
             #print(szeile48)
             szeile49= str(a)[1405:1431]   #diff 29 laenge 26
             #print(szeile49)
             print("-----------")
                                      
             szeile = szeile1+"\n"+szeile7+"\n"+szeile9+"\n"
             #szeile = szeile1+"\n"+szeile5+"\n"+szeile6+"\n"+szeile7+"\n"+szeile8+"\n"+szeile9+"\n"
             szeile = szeile+szeile34+"\n"
             #szeile = szeile+szeile15+"\n"+szeile16+"\n"+szeile20+"\n"+szeile21+"\n"+szeile33 +"\n"+szeile34+"\n\n"+szeile37+"\n"
             szeile = szeile+szeile39+"\n"
             #szeile = szeile+szeile39+"\n"+szeile40+"\n"+szeile41+"\n"+szeile42
             print(szeile)
             #######################msg#############################################

             statzeile=adzeile.split()
             #zlist=[]
             i=6
             ti=1
             print(" beginn s-schleife ")
             
             while i <= 205:
                 print(i)   ##205
                 print(ti)  ##48
                 
             #    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3])
             #   print(lzeile[i])
             #    zlist[ti] = (float(lzeile[i]) / 1000)
             #    print(" z"+str(ti)+" = " + str(zlist[ti]))
             #    print("pylontech/"+str(ftopicz)+"/z"+str(ti)+" "+ str(zlist[ti]))
                 if ti < 14 :
                    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3]) 
                    statlistb.append(statzeile[i]+" "+ statzeile[i+1])
                    statlist.append(statzeile[i+3])
                    i += 4
                 elif ti > 13 and ti < 24 : 
                    print(statzeile[i]+" "+ statzeile[i+1]+" "+ statzeile[i+2] +" "+ statzeile[i+4]) 
                    statlistb.append(statzeile[i]+" "+ statzeile[i+1]+" "+ statzeile[i+2])
                    statlist.append(statzeile[i+4])                    
                    i += 5
                 elif ti > 23 and ti < 35:  
                    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3]) 
                    statlistb.append(statzeile[i]+" "+ statzeile[i+1])
                    statlist.append(statzeile[i+3])
                    i += 4
                 elif ti == 35 : 
                    print(statzeile[i]+" "+ statzeile[i+1]+" "+ statzeile[i+2] +" "+statzeile[i+4]) 
                    statlistb.append(statzeile[i]+" "+ statzeile[i+1]+" "+ statzeile[i+2])
                    statlist.append(statzeile[i+4]) 
                    i += 5
                 elif ti > 35 and ti < 42:  
                    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3]) 
                    statlistb.append(statzeile[i]+" "+ statzeile[i+1])
                    statlist.append(statzeile[i+3])
                    i += 4                    
                 elif ti == 42 :  
                    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3]) 
                    statlistb.append("HT05C Cnt")
                    statlist.append(statzeile[i+3])
                    i += 4    
                 elif ti == 43 :  
                    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3]) 
                    statlistb.append("LT05C Cnt")
                    statlist.append(statzeile[i+3])
                    i += 4       
                 elif ti > 43 :  
                    print(statzeile[i]+" "+ statzeile[i+1] +" "+ statzeile[i+3]) 
                    statlistb.append(statzeile[i]+" "+ statzeile[i+1])
                    statlist.append(statzeile[i+3])
                    i += 4   
                    
                 ti += 1
               
             print(" SSSSSSSSSSSSSSSSS ende s-schleife ")
             #ftopicz = ftopicz + 1
         



   
   ######################
   if (stopictyp==4) :    #info=4
      print("stopictyp=4 "+str(stopictyp)+" p_flag "+str(p_flag)+ " s_flag "+str(s_flag)+" len-a "+str(len(a)) ) 
      #print(a)
      if (len(a)>500):
          #print(a)
          suchtopic="pyloni"
          ftopic = mtopic.find(suchtopic)
          if (ftopic==0):
             i_flag=i_flag+2
   if (i_flag>1):    
       suchtopic="pyloni"
       print(" find suchtopic = "+suchtopic)
       ftopic = mtopic.find(suchtopic)
       if (ftopic==0):
          print("topic pyloni "+suchtopic+"  gefunden !!! ")
          print("PPPEEEEEEEEEEEEEEEEEEEEEEEEEEEEE"+str(len(a)))
          print(a)
          adzeile = str(a)        #message nach string
          
          ######################msg#############################
          print("Master Info ----->>>>>>>> ")
          izeile1= str(a)[9:34]     #laenge 25  
          print(izeile1)
          izeile2= str(a)[36:63]   #diff 27-laenge 27        
          print(izeile2)
          izeile3= str(a)[66:95]   #diff 30 -laenge 28
          print(izeile3)
          izeile4= str(a)[97:135]   #diff 31 laenge 37
          print(izeile4)
          izeile5= str(a)[137:165]   #diff 40 laenge 28
          print(izeile5)
          izeile6= str(a)[167:194]   #diff 30 laenge 27
          print(izeile6)
          izeile7= str(a)[196:223]   #diff 29 laenge 27 
          print(izeile7)
          izeile8= str(a)[225:252]   #diff 29 laenge 27
          print(izeile8)
          izeile9= str(a)[254:285]   #diff 141
          print(izeile9)
          
          izeile10= str(a)[287:326]   #diff 30 laenge 37  ###
          print(izeile10)
          izeile11= str(a)[331:363]   #diff 29 laenge 27 
          print(izeile11)
          izeile12= str(a)[365:390]   #diff 29 laenge 27
          print(izeile12)
          izeile13= str(a)[392:423]   #diff 141
          print(izeile13)
          
          izeile14= str(a)[425:456]   #diff 30 laenge 37
          print(izeile14)
          izeile15= str(a)[458:486]   #diff 29 laenge 27 
          print(izeile15)
          izeile16= str(a)[488:516]   #diff 29 laenge 27
          print(izeile16)
          print("-----------------")
          #izeile = izeile1+"\n"+izeile2+"\n"+izeile3+"\n"+izeile4+"\n"+izeile5+"\n"+izeile6+"\n"+izeile7+"\n"+izeile8+"\n"
          izeile = izeile1+"\n"+izeile2+"\n"+izeile3+"\n"+izeile5+"\n"
          #izeile = izeile+izeile9+"\n"+izeile11+"\n"+izeile12+"\n"+izeile13+"\n"+izeile14+"\n"+izeile15+"\n"+izeile16
          izeile = izeile+izeile9+"\n"+izeile11+"\n"+izeile12+"\n"+izeile13+"\n"+izeile15+"\n"+izeile16
          print(izeile)
          ######################msg#############################
          print("Master Info ----->>>>>>>> ")
          
          #lzeile=adzeile.split()
          #zlist=[]
          i=0
          j=0
          k=0
          print(" beginn i-msg schleife ")
          #while j <= 135:
          #    #print(j)
          #    i=0
          #    while i <= 9:
          #       #print(i) 
          #       #print( lzeile[pwrlisti[i]+j] )
          #       if (i<5) :
          #           #print( float(lzeile[pwrlisti[i]+j])/1000 )
          #           pwrlist2d[k][i] = float(lzeile[pwrlisti[i]+j])/1000
          #       elif (i<9) :
          #           #print( lzeile[pwrlisti[i]+j] )
          #           pwrlist2d[k][i] = lzeile[pwrlisti[i]+j]
          #       elif (i==9) :
          #           #print( str(lzeile[pwrlisti[i]+j])[:-1] )
          #           pwrlist2d[k][i] = str(lzeile[pwrlisti[i]+j])[:-1]
          #       i += 1
          #
          #    j += 17
          #    k += 1
          print(" ende i-msg schleife ")
          #s_flag=s_flag+1
          

         
          
def on_connect(client, userdata, flags, rc):
    if rc==0:
        client.connected_flag=True #set flag
        client.subscribe(topicr)
    else:
        print("Bad connection Returned code=",rc)
        client.loop_stop()  
def on_disconnect(client, userdata, rc):
   pass
   #print("client disconnected ok")
def on_publish(client, userdata, mid):
   time.sleep(1)
   print("In on_pub callback mid= "  ,mid)


def Create_connections(nclients,port,SSL_Flag=False):
   for i in range(nclients):
      if SSL_Flag:
         cname ="python-ssl"+str(i)
      else:
         cname ="python-"+str(i)
      client = mqtt.Client(cname)             #create new instance

      if SSL_Flag:
         client.tls_set('c:/python34/steve/MQTT-demos/certs/ca-pi.crt')
      #client.connected_flag=False #create flag in client

      client.connect(broker,port)           #establish connection
      #client.on_log=on_log #this gives getailed logging
      client.on_connect = on_connect
      client.on_disconnect = on_disconnect
      #client.on_publish = on_publish
      client.on_message = on_message
      clients.append(client)
      client.loop_start()
      while not client.connected_flag:
         time.sleep(0.05)


mqtt.Client.connected_flag=False #create flag in class
clients=[]
no_threads=threading.active_count()
print("current threads =",no_threads)
print("Creating Normal Connections ",Normal_connections," clients")
Create_connections(Normal_connections,port,False)
if SSL_Connections!=0:
   print("Creating SSL Connections ",SSL_Connections," clients")
   Create_connections(SSL_Connections,ssl_port,True)


print("All clients connected ")
time.sleep(3)  ##5
#
count =0
no_threads=threading.active_count()
print("current threads =",no_threads)
print("Publishing ")
Run_Flag=True
try:
   while Run_Flag:
      i=0
      for client in clients:
         counter=str(count).rjust(6,"0")
         #message=str(z1)
         #if qi > 40 :
         msg="client "+ str(i) +  " "+counter+"XXXXXX "+message
         msg=str(z1)
         print(" client schleife " + str(count) )
         #print(s_flag)
         #################################
         if (stopictyp==1) :    #pwr=1
             if (p_flag>1):
                 print(" beginn senden schleife ")
                 print("SPPPSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
                 ##################msg####################
                 msg = pzeile 
                 topics="bat/p"
                 print(topics)
                 client.publish(topics,msg)
                 pzeile = ""
                 ##################msg####################
                 
                 s=0
                 t=0
                 while t <= 7:
                     s=0
                     while s <= 9:
                         #print(s)
                         print("pylontech/"+str(t+1)+"/"+str(pwrlistb[s])+" "+str(pwrlist2d[t][s]))          
                         msg=str( pwrlist2d[t][s] ) 
                         topics="pylontech/"+str(t+1)+"/"+str(pwrlistb[s])
                         s += 1
                         client.publish(topics,msg)
                         #time.sleep(0.1)
                     t += 1
                 print(" ende senden schleife ")
                 #client.publish(topics,msg)
                 #client.publish("pyon1/z1",str(z1))
                 p_flag=0
                 stopictyp = stopictyp + 1
                 #time.sleep(0.1)
                 print("publishing client "+ str(i))
                 print("SEPPPSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
         #################################
         elif (stopictyp==2) :  #bat=2
             if (s_flag>1):
                print(" beginn senden schleife ")
                print("SASSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
                ###############msg##########################
                print(" anfang senden b-msg")
                msg = bzeile 
                topics="bat/b"+str(ftopicz)
                print(topics)
                client.publish(topics,msg)
                print(" ende senden b-msg")
                bzeile = ""
                ###############msg##########################
                s=1
                while s <= 15:
                     #print(s)
                     print(zlist[s])
                     print("pylontech/1/z"+str(s)+" "+ str(zlist[s]))
                     msg=str(zlist[s])
                     topics="pylontech/"+str(ftopicz)+"/z"+str(s)
                     s += 1
                     client.publish(topics,msg)
                     #time.sleep(0.1)
            
                print(" ende senden schleife ")
                #client.publish(topics,msg)
                #client.publish("pyon1/z1",str(z1))
                s_flag=0
                #ftopicz = ftopicz + 1
                stopictyp = stopictyp + 1
                #time.sleep(0.1)
                print("publishing client "+ str(i))
                print("SESSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
         ###############################
         
         

         elif (stopictyp==3) :  #stat=3
             if (s_flag>1):
                print(" beginn senden s-msg-schleife ")
                print("SASSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
                ################msg########################
                msg = szeile 
                topics="bat/s"+str(ftopicz)
                print(topics)
                client.publish(topics,msg)
                print(" ende senden s-msg-schleife ")
                szeile = "" 
                ################msg########################
                s=1
                #global statlistb
                #global statlist
                while s <= 47:
                #     #print(s)
                #     print(zlist[s])
                #     print("pylontech/1/z"+str(s)+" "+ str(zlist[s]))
                      msg=str(statlist[s])
                      topics="pylontech/"+str(ftopicz)+"/s/"+statlistb[s]
                      s += 1
                      client.publish(topics,msg)
                      #time.sleep(0.1)
                #msg = szeile 
                statlist=[]
                statlistb=[]
                #topics="bat/s"+str(ftopicz)
                #print(topics)
                #client.publish(topics,msg)
                print(" ende senden s-msg-schleife ")
                #szeile = ""
                #client.publish(topics,msg)
                #client.publish("pyon1/z1",str(z1))
                s_flag=0
                ftopicz = ftopicz + 1
                #stopictyp = stopictyp + 1
                stopictyp = 1
                #time.sleep(0.1)
                print("publishing client "+ str(i))
                print("SESSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
         ###############################
             

         elif (stopictyp==4) :  #info=4
             if (i_flag>1):
                print(" beginn senden i-msg-schleife ")
                print("SASSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
                ######################msg###################
                msg = izeile 
                topics="bat/i"
                print(topics)
                client.publish(topics,msg)
                print(" ende senden i-msg-schleife ")
                izeile = ""
                ######################msg###################
                s=1
                #while s <= 15:
                #     #print(s)
                #     print(zlist[s])
                #     print("pylontech/1/z"+str(s)+" "+ str(zlist[s]))
                #     msg=str(zlist[s])
                #     topics="pylontech/"+str(ftopicz)+"/z"+str(s)
                #     s += 1
                #     #client.publish(topics,msg)
                #     #time.sleep(0.1)
                #msg = izeile 
                #topics="bat/i"
                #print(topics)
                #client.publish(topics,msg)
                #print(" ende senden i-msg-schleife ")
                izeile = ""
                #client.publish(topics,msg)
                #client.publish("pyon1/z1",str(z1))
                i_flag=0
                #ftopicz = ftopicz + 1
                stopictyp = 1
                #time.sleep(0.1)
                #print("publishing client "+ str(i))
                print("SESSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS")
         ###############################
             
         
         i+=1
      ##time.sleep(10)#now print messages
      time.sleep(0.3)#now print messages   ###3++++++
      qi+=1
      #if qi > 50 :
      print("queue length=",len(out_queue))
      qi = 0
      #for x in range(len(out_queue)):
      #   print(out_queue.pop())
      count+=1
      if count > 300 :
         count = 1 
         out_queue=[] #use simple array to get printed messages in some form of order
         message="test message"
      #time.sleep(5)#wait
except KeyboardInterrupt:
   print("interrupted  by keyboard")

#client.loop_stop() #stop loop
for client in clients:
   client.disconnect()
   client.loop_stop()
   print(" client.loop_stop ")
#allow time for allthreads to stop before existing
#time.sleep(10)
time.sleep(3)   ##5

